#ifndef __CVCardPhoneNumbers_h__
#define __CVCardPhoneNumbers_h__

#define VCARD_MAXNAME_LEN       61
#define VCARD_MAXNUMBER_LEN     21

#define VCARD_STR_HOME  "HOME"
#define VCARD_STR_WORK  "WORK"
#define VCARD_STR_CELL  "CELL"

enum vcard_element_types { VCARD_NUMBER_DEFAULT=0,
                           VCARD_NUMBER_HOME,
                           VCARD_NUMBER_WORK,
                           VCARD_NUMBER_CELL,
                           VCARD_NAME,
                           VCARD_NOT_A_USED_ELEMENT };

enum vcard_encoding_type { VCARD_ENCODING_CHARSET_UTF_8=0,
                           VCARD_ENCODING_QUOTED_PRINTABLE,
                           VCARD_ENCODING_UNKNOWN };
                           
class CVCardPhoneNumbers
{
public:
  CVCardPhoneNumbers();
  // CVCardPhoneNumbers(char *aData);
  ~CVCardPhoneNumbers();

  void parseVCard( char *aData);
  void init( char *phonebookFilename);

  char* getName();
  char* getNumber();  

  char* setName( char *aData);

  void dumpElements(void);

private:
  void setNumber(int Type, char *aData);  
  vcard_element_types getVCardElementType( char *aData);
  bool parseVCardElement( vcard_element_types aElementType, char *aData);
  bool storeElement(vcard_element_types aElementType, char *aData);     
  // void writeNumberToFile(char *phoneNumber);
  void writeNumberToFile(char *phoneNumber, vcard_element_types aElementType);
  
  vcard_encoding_type getEncodingType(char *aData);
  void convertQPToAscii(vcard_encoding_type aType, char *aData);

private:
  char iName[VCARD_MAXNAME_LEN];
  char iNumber[VCARD_MAXNUMBER_LEN];

  char iFilename[512]; 
};

#endif // __CVCardPhoneNumbers_h__
